/**
 * Stage section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoStage(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preStage;
    var subController = ctrl.stage;
    var changeController = ctrl.stage;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new SlaveNoonTwoRefuse(ctrl);
    var secondNext = new SlaveNoonTwoSmile(ctrl);
    var thirdNext = new SlaveNoonTwoPose(ctrl);

    var firstChoice = SlaveNoonTwoStageChoice.REFUSE;
    var secondChoice = SlaveNoonTwoStageChoice.SMILE;
    var thirdChoice = SlaveNoonTwoStageChoice.POSE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var dick = ctrl.misc.dick();
        var injected = ctrl.gag.has();
        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var toReturn = `[p]
                            Seemingly directing his anger for the lupine towards you,
                            the caravan master grabs you by the collar, pulling you along with as he strides towards the wooden stage.
                            You can only [b]barely[/b] keep up with his upset pace, but fortunately the podium isn't too far off.
                            "[color=brown]Come, people, gather 'round!
                            The main event is about to begin![/color]"
                            The human announces, addressing the people on the streets.
                            You have a [b]bad[/b] feeling about this.
                        [/p]
                        [p]
                            A small crowd slowly forms in front of the stage, numbering more than a dozen heads.
                            This must be at least half the people that live here, if not more!
                            No sign of Seki, though.
                            Most of them are talking amongst themselves, taking the occasion as a big social gathering,
                            which doesn't seem to amuse the already annoyed caravan master very much.
                            "[color=brown]Hear ye, hear ye!
                            [b]Settle down![/b]
                            [small]Filthy peasants.[/small][/color]"
                            That last part was naught but a whisper, one you [b]hope[/b] only [b]you[/b] heard, lest this [i]auction[/i] turns into a [b]lynching[/b].
                        [/p]
                        [p]
                            The mob slowly goes silent, their attention snagged by the authoratively dressed human and your naked frame besides him.
                            You shyly try to conceal your nudity by standing [i]behind[/i] the caravan master, but he [b]firmly[/b] yanks you back into place at his side.
                            Worse yet, as the [b]show[/b] is about to start, he crudely picks you up,
                            effortlessly lifts you off the ground, and practically [b]throws[/b] you ontop of the wooden stage.
                            You quickly rise to your feet atop the podium, using your hands and your tail both to cover your [i]private parts[/i].
                        [/p]
                        [p]
                            With nowhere to run and nowhere to hide, you are at the mercy of the crowd's leering stares.
                            You can feel them [b]inspecting[/b] you, [b]judging[/b] you, estimating your worth in gold,
                            whispering to one another to comment on your [i]humble[/i] appearance, or to share how much they're willing to bid for your [b]body[/b].
                        [/p]
                        [p]
                            Amongst the onlookers, a few stick out the most.
                            There's a voluptuous vixen dressed in naught but a black shirt, a cowboy hat and some spurred, leather boots.
                            The blouse barely covers her loins.
                            You wonder if she's wearing anything [i]underneath[/i].
                            Next to her, there are a pair of muscular anthro horses.
                            Probably farmers.
                            They look like siblings.
                            Brothers or twins or something, maybe?
                            You don't know.
                            A lot of horses look alike to you.
                        [/p]
                        [p]
                            To the side, there stands an odd family.
                            A human mother and father, with a distinctly [b]avian[/b] son.
                            You don't know much about birds, but you think he's an [b]eagle[/b].
                            He looks kind of like one of Seki's relatives that you met a long time ago.
                            You briefly wonder how a bird and human could [i]mix[/i], but you decide not to linger on it for too long.
                            A final person of note, standing amidst a few of the more common farmers, is a single [b]goblin[/b].
                            You don't think he's from around here.
                            Behind the rabble, Fenrir is leaning slickly against the side of a building,
                            now dressed and eager to see the auction play out.
                        [/p]
                        [p]
                            With the crowd reduced to whispers, the caravan master begins to address them.
                            "[color=brown]I am [b]Bartholomew Grabgold[/b], royal tax collector,
                            appointed by the [b]king[/b] himself, currently serving the baron-regent.
                            But make no mistake, today I am [b]not[/b] here to [b]take[/b] your money.[/color]"
                            The chubby man chuckles, trying to lighten his own mood.
                            "[color=brown]That doesn't mean I intend to leave here empty-handed, though.[/color]"
                            A small, awkward pause.
                            The farmers don't seem to understand the joke.
                            Heck, you're not sure if [b]you[/b] get it.
                        [/p]
                        [p]
                            Disdain and frustration a bit more clear in his voice, [i]Bartholomew[/i] extends his arm towards you,
                            directing attention to your naked form before continuing.
                            "[color=brown]Today, I have come before you with a [b]slave[/b] to sell.
                            And not just [b]any[/b] slave.
                            You see, this kobold was [b]stupid[/b] enough to attempt to [b]steal[/b] from an imperial money transport.
                            It wanted to take gold to be used for the betterment of [b]all[/b] of mankind, to use for its own [b]selfish[/b] needs.[/color]"
                            You can almost [b]feel[/b] the crowd grow more [i]hostile[/i] towards you.
                        [/p]
                        [p]
                            "[color=brown]Not the smartest thing, is it?
                            Don't worry, the dumb lizard can still be used for simple, menial labor.
                            But you shouldn't buy this slave only to make it clean your house or work the fields.
                            No, instead, you should spend your coin on little ${name} here to [b]punish[/b] ${dick ? `him` : `her`}.
                            To make an [b]example[/b] out of ${dick ? `him` : `her`}.
                            To show ${dick ? `him` : `her`}, and indeed, [b]all[/b] kobolds,
                            that [b]any[/b] transgressions against their [b]superiors[/b] is a one-way ticket to [b]hell[/b] on earth.[/color]"
                        [/p]
                        [p]
                            The human has the crowd eating out of his hand.
                            Still, these people are but simple farmers.
                            You doubt many -- if any -- of them have the [b]means[/b] to [i]buy[/i] you.
                            Being relatively [i]poor[/i], surely they won't spend a bunch of money only to [b]torture[/b] or outright [b]kill[/b] you, would they?
                        [/p]
                        [p]
                            "[color=brown]${injected ? `As you can tell by the gag in its mouth, this lizard is ill-mannered and plain-out [b]rude[/b].
                            Buy it to teach it a [b]lesson[/b].
                            Whip it until it passed out.
                            ${fucked ? `Make it wish it was never even born.` : `Take its virginity.`}
                            Fuck it until it can no longer walk.
                            Break all of its limbs, and then slice its throat.
                            Make it [b]suffer[/b] until its very last breath.
                            ` : `While not the sharpest tool in the shed, this lizard has proven to be a bit more [b]cooperative[/b] than the others.
                            Perfect for all you [b]lonely men[/b] out there.
                            I can't ensure it won't [b]bite[/b], but there's two other holes for you to [b]fuck[/b] if you don't want to risk it.
                            Or you can pull out its teeth for maximum security.
                            ${fucked ? `One of its holes might still be virginal.
                            Find out which one after the auction.` : `Did I mention it's a virgin?
                            [b]Extra tight[/b] on the first go-around.
                            Guaranteed to be a [i]suitable[/i] fit for even a child.
                            A perfect gift for your firstborn son.`}`}[/color]"
                        [/p]
                        [p]
                            The crowd seems [b]very[/b] enticed.
                            [b]Barto[/b] appears to have a silver tongue when it comes to selling things.
                            His audience excited, the human turns to you.
                            "[color=brown][b]Smile, slave![/b][/color]" comes the simple command.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Refuse</button>`;

        var tooltip = global.parser.parse(`You aren't happy. Why would you pretend to be?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Smile</button>`;

        var tooltip = global.parser.parse(`You don't want to get hurt. Do as he says.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Pose</button>`;

        var tooltip = global.parser.parse(`Go above and beyond what is requested of you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var SlaveNoonTwoStageChoice = {
    REFUSE: 1,
    SMILE: 2,
    POSE: 3
};
