/**
 * Enveloped section of the unknown scene.
 * @param {ForestController} controller The forest controller.
 */
function ForestUnknownEnvelopedContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = `leftForDeadContinueButton`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var cock = ctrl.unknown.cock();
        var pants = ctrl.unknown.pants();
        var pantsPopup = global.kobold.inventory.createItemWithTooltip(pants);
        var underwear = ctrl.unknown.underwear();
        var underwearPopup = global.kobold.inventory.createItemWithTooltip(underwear);
        var toReturn = `[p]
                            Darkness envelops the land, the small bit of sunlight that illuminated this part of the deepwoods fading away as day turns to night.
                            While you had kept brave so far, a few tears finally flow from your eyes.
                            You feel used and abused.
                            Robbed of your ${cock ? "masculinity" : "virginity"}.
                        [/p]
                        [p]
                            You reach down, sliding your hand underneath the waistband of your ${pants ? "pants" : "underwear"}.
                            The warm goop seeping from your loins, much of which was spilled on your meagre clothing, feels [b]sticky[/b] to the touch.
                            Like someone emptied a jar of honey inside of you.
                            Without bothering to get up off of the ground, you clean your slit with the flat of your hand to the best of your ability.
                        [/p]
                        [p]
                            As you wipe the golden syrup off on a nearby patch of moss, its sweet smell reaches your nose.
                            It sickens you enough to motivate you to rise to your shaky feet.
                            Out of the corner of your eye, you spot a tiny consolation prize: the tattered remains of your shirt.
                            You pick it up off of the ground, and and slowly don it.
                            At least this wasn't all for nothing, or so you claim, to try to cheer yourself up.
                        [/p]
                        [p]
                            It works, to some effect.
                            Your tears stop flowing, and your mind clears just enough for you to start thinking about survival, rather than about [i]wanting[/i] to die.
                            You don't think you can find your way home through the darkness.
                            But you can't stay here, either.
                            That monster might be back, or maybe something [i]even worse[/i] than it.
                        [/p]
                        [p]
                            Disheartened and broken, both mentally and physically, you set off in a random direction, 
                            hoping to make it out of the deepwoods [i]without[/i] any more of your orifices being [b]defiled[/b] by plants,
                            beasts, or whatever else may be waiting for you in the uncharted parts of the forest.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.unknown.hasContinued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unknown.continue();
            loadNextPart("RiversideMarsh", "Deepwoods");
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "forestUnknownEnvelopedContinue";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.unknown.yank.envelop.continued()) {
            return "";
        }

        global.ui.applyTheme("forest_night");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.unknown.yank.envelop.continueChange();
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.unknown.yank.envelop.continued()) {
            return;
        }
        // REGISTER CHILDREN HERE

        if (ctrl.unknown.hasContinued()) {
            return;
        }

        registerContinueListener();
    };
}
